net.sf.okapi.common.plugins

## Class PluginItem

- java.lang.Object
- - net.sf.okapi.common.plugins.PluginItem

-     public class PluginItem
      extends java.lang.Object

  Encapsulates the generic information for a plug-in item.

  The information is composed of the type of the plug-in, the name of the class that implements it, and optional class information for the optional parameters editor associated with the plug-in.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `TYPE_IEDITORDESCRIPTIONPROVIDER` Identifies a plug-in implementing `IEditorDescriptionProvider`.
    `static int` | `TYPE_IEMBEDDABLEPARAMETERSEDITOR` Identifies a plug-in implementing `IEmbeddableParametersEditor`.
    `static int` | `TYPE_IFILTER` Identifies a plug-in implementing `IFilter`.
    `static int` | `TYPE_IPARAMETERSEDITOR` Identifies a plug-in implementing `IParametersEditor`.
    `static int` | `TYPE_IPIPELINESTEP` Identifies a plug-in implementing `IPipelineStep`.
    `static int` | `TYPE_IQUERY` Identifies a plug-in implementing `IQuery`.
    `static int` | `TYPE_MAIN` Convenience mask for all main types of plug-ins.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PluginItem(int type, java.lang.String className)` Creates a new plug-in item of a given type and class name.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getClassName()` Gets the name of the class implementing this plug-in.
    `ClassInfo` | `getEditorDescriptionProvider()` Gets the class information for the IEditorDescriptionProvider class associated with this plug-in, or null if there is none.
    `ClassInfo` | `getEmbeddableParamsEditor()` Gets the class information for the IEmbeddableParamsEditor class associated with this plug-in, or null if there is none.
    `ClassInfo` | `getParamsEditor()` Gets the class information for the IParameterEditor class associated with this plug-in, or null if there is none.
    `int` | `getType()` Gets the type of this plug-in.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### TYPE_IFILTER

          public static final int TYPE_IFILTER

      Identifies a plug-in implementing `IFilter`.
      See Also:
        Constant Field Values

    - #### TYPE_IPIPELINESTEP

          public static final int TYPE_IPIPELINESTEP

      Identifies a plug-in implementing `IPipelineStep`.
      See Also:
        Constant Field Values

    - #### TYPE_MAIN

          public static final int TYPE_MAIN

      Convenience mask for all main types of plug-ins.
      See Also:
        Constant Field Values

    - #### TYPE_IPARAMETERSEDITOR

          public static final int TYPE_IPARAMETERSEDITOR

      Identifies a plug-in implementing `IParametersEditor`.
      See Also:
        Constant Field Values

    - #### TYPE_IEMBEDDABLEPARAMETERSEDITOR

          public static final int TYPE_IEMBEDDABLEPARAMETERSEDITOR

      Identifies a plug-in implementing `IEmbeddableParametersEditor`.
      See Also:
        Constant Field Values

    - #### TYPE_IEDITORDESCRIPTIONPROVIDER

          public static final int TYPE_IEDITORDESCRIPTIONPROVIDER

      Identifies a plug-in implementing `IEditorDescriptionProvider`.
      See Also:
        Constant Field Values

    - #### TYPE_IQUERY

          public static final int TYPE_IQUERY

      Identifies a plug-in implementing `IQuery`.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PluginItem

          public PluginItem(int type,
                            java.lang.String className)

      Creates a new plug-in item of a given type and class name.
      Parameters:
        `type` - the type of the new plug-in.
        `className` - the class name of the new plug-in.

  - ### Method Detail

    - #### getType

          public int getType()

      Gets the type of this plug-in.
      Returns:
        the type of this plug-in.

    - #### getClassName

          public java.lang.String getClassName()

      Gets the name of the class implementing this plug-in.
      Returns:
        the name of the class implementing this plug-in.

    - #### getParamsEditor

          public ClassInfo getParamsEditor()

      Gets the class information for the IParameterEditor class associated with this plug-in, or null if there is none.
      Returns:
        the class information for the IParameterEditor class associated with this plug-in.

    - #### getEmbeddableParamsEditor

          public ClassInfo getEmbeddableParamsEditor()

      Gets the class information for the IEmbeddableParamsEditor class associated with this plug-in, or null if there is none.
      Returns:
        the class information for the IEmbeddableParamsEditor class associated with this plug-in.

    - #### getEditorDescriptionProvider

          public ClassInfo getEditorDescriptionProvider()

      Gets the class information for the IEditorDescriptionProvider class associated with this plug-in, or null if there is none.
      Returns:
        the class information for the IEditorDescriptionProvider class associated with this plug-in.